﻿Class MainWindow 

    Delegate Function InterestFunc(ByVal p As Decimal, ByVal r As Decimal,
                                   ByVal y As Integer) As Decimal

    Private Sub SimleButton_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles SimpleButton.Click

        Dim f = Function(p As Decimal, r As Decimal, y As Integer) p *
                    (1 + y * r)
        Interest(f)

    End Sub

    Private Sub CompoundButton_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles CompoundButton.Click

        Dim f = Function(p As Decimal, r As Decimal, y As Integer) p *
                    Math.Pow(1 + r / 2, 2 * y)
        Interest(f)

    End Sub

    Sub Interest(ByVal f As InterestFunc)

        Dim p, r, Total As Decimal
        Dim y As Integer

        If Decimal.TryParse(PrincipalTextBox.Text, p) And
            Decimal.TryParse(RateTextBox.Text, r) And
            Integer.TryParse(YearTextBox.Text, y) Then
            r /= 100
            Total = Math.Floor(f(p, r, y))
            Label1.Content = "元利合計は " & Total & " です"
        Else
            Label1.Content = "数値を入力してください"
        End If

    End Sub
End Class
