﻿Class MainWindow 

    Private Sub TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.TextChangedEventArgs)

        Dim High, Low As Integer
        Dim Message As String

        If Integer.TryParse(HighTextBox.Text, High) AndAlso
            Integer.TryParse(LowTextBox.Text, Low) Then
            If High < Low Then
                Message = "最低血圧が最高血圧よりも低いです"
            ElseIf High < 100 And Low < 90 Then
                Message = "低血圧です"
            ElseIf High < 140 And Low < 90 Then
                Message = "正常血圧です"
            ElseIf High < 160 And Low < 100 Then
                Message = "軽症高血圧です"
            ElseIf High < 180 And Low < 110 Then
                Message = "中等症高血圧です"
            Else
                Message = "重症高血圧です"
            End If
            Label1.Content = Message
        Else
            Label1.Content = "整数を入力してください"
        End If

    End Sub

    Private Sub Window_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded

        Me.AddHandler(TextBox.TextChangedEvent,
                      New TextChangedEventHandler(AddressOf TextBox_TextChanged))

    End Sub
End Class
