﻿Imports System.IO, System.Text
Class MainWindow

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button1.Click

        Dim ReadFileName = MyPath("Data.txt")
        Dim WriteFileName = MyPath("Linenum.txt")

        Dim fs1, fs2 As FileStream
        Dim sr As StreamReader
        Dim sw As StreamWriter
        Dim Buffer As String

        Dim LineNum As Integer = 1

        Try
            fs1 = New FileStream(ReadFileName, FileMode.Open)
            fs2 = New FileStream(WriteFileName, FileMode.Create)
            sr = New StreamReader(fs1, Encoding.GetEncoding(
                                  "shift_jis"))
            sw = New StreamWriter(fs2, Encoding.GetEncoding(
                                  "shift_jis"))

            Buffer = sr.ReadLine()
            Do Until Buffer Is Nothing
                sw.WriteLine("{0:0000}:{1}", LineNum, Buffer)
                LineNum += 1
                Buffer = sr.ReadLine()
            Loop
            Label1.Content = "処理が終わりました"
        Catch ex As FileNotFoundException
            Label1.Content = "ファイルが見つかりません"
        Catch ex As UnauthorizedAccessException
            Label1.Content = "アクセス権がありません"
        Catch ex As IOException
            Label1.Content = ex.Message
        Finally
            If sr IsNot Nothing Then
                sr.Close()
            End If
            If sw IsNot Nothing Then
                sw.Close()
            End If
        End Try

    End Sub

    Function MyPath(ByVal Filename As String)

        Return Path.Combine(Path.GetDirectoryName(
                            Application.ResourceAssembly.Location), Filename)

    End Function
End Class
