﻿Imports System.Windows.Threading
Class MainWindow

    Const CountSeconds As Integer = 10
    Dim MyTimer As DispatcherTimer
    Dim BaseDateTime As Date

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button1.Click

        If MyTimer.IsEnabled Then
            MyTimer.Stop()
            Button1.Content = "開始"
            Label1.Content = "カウントを中止しました"
        Else
            Button1.Content = "中止"
            BaseDateTime = Date.Now
            MyTimer.Start()
        End If

    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As EventArgs)

        Dim Lapse As TimeSpan = Date.Now - BaseDateTime
        Label1.Content = CountSeconds - Math.Floor(
            Lapse.TotalSeconds)
        If Lapse.TotalSeconds > CountSeconds Then
            MyTimer.Stop()
            Button1.Content = "開始"
            MessageBox.Show("タイムアウトになりました", "カウントダウン",
                            MessageBoxButton.OK, MessageBoxImage.Information)
        End If

    End Sub

    Private Sub Window_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded

        MyTimer = New DispatcherTimer()
        MyTimer.Interval = New TimeSpan(0, 0, 0, 0, 50)
        AddHandler MyTimer.Tick, AddressOf Timer1_Tick

    End Sub
End Class
