﻿Imports System.IO, System.ComponentModel
Class MainWindow

    Dim MyBackgroundWorker As BackgroundWorker

    Private Sub Window_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded

        MyBackgroundWorker = New BackgroundWorker()
        AddHandler MyBackgroundWorker.DoWork,
            AddressOf BackgroundWorker_DoWork
        AddHandler MyBackgroundWorker.RunWorkerCompleted,
            AddressOf BackgroundWorker_RunWorkerCompleted

    End Sub

    Private Sub BackgroundWorker_DoWork(ByVal sender As Object, ByVal e As DoWorkEventArgs)

        For i As Integer = 1 To 5
            WriteFile(Path.Combine(Path.GetDirectoryName(
                                   Application.ResourceAssembly.Location),
                               "Alphabet" & i))
        Next

    End Sub

    Private Sub BackgroundWorker_RunWorkerCompleted(ByVal sender As Object, ByVal e As RunWorkerCompletedEventArgs)

        If e.Error Is Nothing Then
            Label1.Content = "処理が終わりました"
        Else
            MessageBox.Show(e.Error.Message, Me.Title,
                            MessageBoxButton.OK,
                            MessageBoxImage.Error)
        End If
        Button1.IsEnabled = True

    End Sub

    Sub WriteFile(ByVal fn As String)

        Dim r As Random = New Random()
        Dim sw As StreamWriter = New StreamWriter(fn)
        Dim s As String =
            "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
        For i As Integer = 1 To 104857600
            sw.Write(s.Chars(r.Next(s.Length)))
        Next
        sw.Close()

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button1.Click

        Button1.IsEnabled = False
        MyBackgroundWorker.RunWorkerAsync()

    End Sub
End Class
