﻿Class MainWindow 

    Private Pressed As Boolean
    Private OldAngle As Double
    Private OldRotate As Double
    
    Private Sub Image1_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseEventArgs) Handles Image1.MouseMove

        If Pressed Then
            Dim p As Point = e.GetPosition(StackPanel1)
            Dim NewAngle As Double = GetAngle(p) - OldAngle
            DirectCast(Image1.RenderTransform, RotateTransform).Angle =
                OldRotate + NewAngle
        End If

    End Sub

    Private Sub Image1_MouseLeftButtonUp(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles Image1.MouseLeftButtonUp

        Mouse.Capture(Nothing)
        Pressed = False
        Image1.Cursor = Nothing

    End Sub

    Private Sub Image1_MouseLeftButtonDown(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles Image1.MouseLeftButtonDown

        Dim p As Point = e.GetPosition(StackPanel1)
        Pressed = True
        Oldangle = GetAngle(p)
        OldRotate = DirectCast(Image1.RenderTransform, 
            RotateTransform).Angle

        Mouse.Capture(sender)
        Image1.Cursor = Cursors.Hand

    End Sub

    Private Function GetAngle(ByVal p As Point) As Double

        Dim CenterX As Double = Image1.ActualWidth / 2
        Dim CenterY As Double = Image1.ActualHeight / 2

        Dim dx = p.X - CenterX
        Dim dy = p.Y - CenterY

        Dim ImageAngle As Double = Math.Atan2(dy, dx)
        Return ImageAngle * 180 / Math.PI

    End Function
End Class
