﻿Imports System.Windows.Media.Animation
Class MainWindow

    Dim FaceImage As BitmapImage()
    Dim IsFace() As Boolean = New Boolean(2) {}
    Dim CardImage As String()

    Private Sub Window_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded

        Dim CardBitmap = Function(u As String) As BitmapImage
                             Return New BitmapImage(New Uri("/Images/" & u, UriKind.Relative))
                         End Function
        FaceImage = New BitmapImage() {CardBitmap("Card1.png"),
                                       CardBitmap("Card2.png"), CardBitmap("Card3.png"), CardBitmap("Card0.png")}
        CardImage = New String() {Image1.Name, Image2.Name, Image3.Name}

    End Sub

    Private Sub Window_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles MyBase.MouseDown

        If TypeOf e.OriginalSource Is Image Then
            Dim ImageIndex As Integer = Array.IndexOf(CardImage,
                                                      CType(e.OriginalSource, Image).Name)
            If ImageIndex > -1 Then
                IsFace(ImageIndex) = Not IsFace(ImageIndex)
            End If
        End If

    End Sub

    Sub ChangeImage(ByVal sender As Object, ByVal e As EventArgs)

        Dim MyClock As Clock = CType(sender, Clock)
        If MyClock.CurrentState = ClockState.Filling Then
            Dim ImageIndex As Integer = Array.IndexOf(CardImage,
                                                      Storyboard.GetTargetName(MyClock.Timeline))
            CType(FindName(CardImage(ImageIndex)), Image).Source =
                FaceImage(If(IsFace(ImageIndex), ImageIndex, 3))
        End If

    End Sub
End Class
