﻿Imports System.Windows.Media.Animation
Class MainWindow

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button1.Click

        Dim WalkValue As Double
        If e.OriginalSource Is Button1 Then
            CType(Image1.RenderTransform, ScaleTransform).ScaleX = 1
            WalkValue = -Image1.Width
        Else
            CType(Image1.RenderTransform, ScaleTransform).ScaleX = -1
            WalkValue = Canvas1.ActualWidth + 15
        End If

        Dim d As DoubleAnimationUsingKeyFrames =
            WalkAnimation(Image1.GetValue(Canvas.LeftProperty),
                          WalkValue)
        Storyboard.SetTarget(d, Image1)
        Storyboard.SetTargetProperty(d, New PropertyPath(
                                     "(Canvas.Left)"))

        Dim WalkStoryboard As Storyboard = New Storyboard()
        WalkStoryboard.Children.Add(d)
        WalkStoryboard.Begin()

    End Sub

    Function WalkAnimation(ByVal FromX As Double, ByVal ToX As Double) As DoubleAnimationUsingKeyFrames

        Dim d As DoubleAnimationUsingKeyFrames =
            New DoubleAnimationUsingKeyFrames()
        Dim t As TimeSpan = New TimeSpan(0)

        For x As Double = FromX To ToX Step Math.Sign(ToX - FromX) * 15
            Dim Frame As DiscreteDoubleKeyFrame =
                New DiscreteDoubleKeyFrame(x, KeyTime.FromTimeSpan(t))
            d.KeyFrames.Add(Frame)
            t = t.Add(New TimeSpan(0, 0, 0, 0, 200))
        Next
        Return d

    End Function
End Class
