﻿Class MainWindow 

    Dim ValueList As List(Of Double) = New List(Of Double)()

    Private Sub GoButton_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles GoButton.Click

        Dim Value As Double
        If Double.TryParse(TextBox1.Text, Value) Then
            Dim c As Integer = 0
            Do Until c > ValueList.Count - 1 OrElse ValueList(c) >
                Value
                c += 1
            Loop
            ValueList.Insert(c, Value)
            CountLabel.Content = "数値は" & ValueList.Count & "個です"
            MedianLabel.Content = "中央値は" & GetMedian(ValueList) &
                "です"
        Else
            MessageBox.Show("実数を入力してください", "エラー",
                            MessageBoxButton.OK, MessageBoxImage.Error)
        End If

    End Sub

    Function GetMedian(ByVal ValueList As List(Of Double)) As Double

        Dim c As Integer = ValueList.Count
        If c Mod 2 = 1 Then
            Return ValueList((c + 1) / 2 - 1)
        Else
            Return (ValueList(c / 2 - 1) + ValueList(c / 2)) / 2
        End If

    End Function

    Private Sub ClearButton_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles ClearButton.Click

        ValueList.Clear()
        CountLabel.Content = "クリアしました"
        MedianLabel.Content = ""

    End Sub
End Class
