﻿Class MainWindow 

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button1.Click

        Dim InputDate, CountDate As Date
        Dim BusinessDay As Integer = 0
        If Date.TryParse(TextBox1.Text, InputDate) Then
            CountDate = New Date(InputDate.Year, InputDate.Month, 1)
            If IsBusinessDate(InputDate) Then
                Do
                    BusinessDay += IIf(IsBusinessDate(CountDate), 1, 0)
                    CountDate = CountDate.AddDays(1)
                Loop Until CountDate > InputDate
                Label1.Content = "月の第" & BusinessDay & "営業日です"
            Else
                Label1.Content = "営業日ではありません"
            End If
        Else
            Label1.Content = "日付を入力してください"
        End If

    End Sub

    Function IsBusinessDate(ByVal d As Date) As Boolean

        Return d.DayOfWeek <> DayOfWeek.Saturday And
            d.DayOfWeek <> DayOfWeek.Sunday

    End Function
End Class
