﻿Class MainWindow 

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button1.Click

        Dim NowDate As Date = Date.Today
        Dim ThisMonthPayDate As Date = PayDate(NowDate)

        If NowDate = ThisMonthPayDate Then
            Label1.Content = "本日は給料日です"
        ElseIf NowDate < ThisMonthPayDate Then
            Label1.Content = String.Format(
                "次の給料日は{0:yyyy年M月d日です}", ThisMonthPayDate)
        Else
            Dim NextPayDate As Date = PayDate(NowDate.AddMonths(1))
            Label1.Content = String.Format(
                "次の給料日は{0:yyyy年M月d日です}", NextPayDate)
        End If

    End Sub

    Function PayDate(ByVal d As Date) As Date

        Dim CurrentDate As Date = New Date(d.Year, d.Month, 25)
        Do Until IsBusinessDate(CurrentDate)
            CurrentDate = CurrentDate.AddDays(-1)
        Loop
        Return CurrentDate

    End Function

    Function IsBusinessDate(ByVal d As Date) As Boolean

        Return d.DayOfWeek <> DayOfWeek.Saturday And
            d.DayOfWeek <> DayOfWeek.Sunday

    End Function
End Class
