﻿Class MainWindow 

    Private Sub ListBox1_SelectionChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs) Handles ListBox1.SelectionChanged

        Label1.FontFamily =
            CType(ListBox1.SelectedItem, ListBoxItem).Tag

    End Sub

    Private Sub CheckBox1_Checked(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles CheckBox1.Checked
        Label1.FontWeight = FontWeights.Bold
    End Sub

    Private Sub CheckBox1_Unchecked(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles CheckBox1.Unchecked
        Label1.FontWeight = FontWeights.Normal
    End Sub

    Private Sub CheckBox2_Checked(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles CheckBox2.Checked
        Label1.FontStyle = FontStyles.Italic
    End Sub

    Private Sub CheckBox2_Unchecked(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles CheckBox2.Unchecked
        Label1.FontStyle = FontStyles.Normal
    End Sub

    Private Sub Window_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded

        For Each Family As FontFamily In Fonts.SystemFontFamilies
            Dim MyItem As ListBoxItem = New ListBoxItem()
            MyItem.Tag = Family
            MyItem.Content = Family.Source
            ListBox1.Items.Add(MyItem)
        Next

    End Sub
End Class
