﻿Imports System.Windows.Media.Animation
Class MainWindow

    Private Sub Window_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded

        Dim ImageStoryboard As Storyboard = New Storyboard()
        Dim MoveAnime As MatrixAnimationUsingPath =
            New MatrixAnimationUsingPath()

        Dim w As Double = Canvas1.ActualWidth
        MoveAnime.Duration = New Duration(New TimeSpan(0, 0, 6))
        MoveAnime.DoesRotateWithTangent = True
        MoveAnime.AutoReverse = True
        MoveAnime.RepeatBehavior = RepeatBehavior.Forever
        Dim SinCurve As PathGeometry = New PathGeometry()
        Dim SinFigure As PathFigure = New PathFigure() With
                                      {.StartPoint = New Point(0, 40)}

        For x As Double = 0 To w
            SinFigure.Segments.Add(New LineSegment(New Point(
                                                   x, Math.Sin(x / w * 4 * Math.PI) * 30 + 40), True))
        Next
        SinCurve.Figures.Add(SinFigure)
        MoveAnime.PathGeometry = SinCurve

        Storyboard.SetTarget(MoveAnime, Image1)
        Storyboard.SetTargetProperty(MoveAnime,
                                     New PropertyPath("RenderTransform.Matrix"))

        ImageStoryboard.Children.Add(MoveAnime)
        ImageStoryboard.Begin()

    End Sub
End Class
